(defvar anarcat/notmuch-attach-regex
  "\\b\\(attache\?ment\\|attached\\)\\b"
  "what is considered a reference to an attachment in an email
  body by the attachment detection hook")

(defun anarcat/notmuch-check-attach ()
  (save-mark-and-excursion ;; this fails somehow: point is at the end of the buffer on error
    (goto-char (point-min))
    (if (re-search-forward anarcat/notmuch-attach-regex nil t)
        (progn 
          (goto-char (point-min))
          (unless (re-search-forward "<#part [^>]*filename=[^>]*>" nil t)
            (or (y-or-n-p "Email seem to refer to attachment, but nothing attached, send anyways?")
                (error "No attachment found, aborting")))))))

(add-hook 'message-send-hook 'anarcat/notmuch-check-attach)
